package org.expeditee.gui;

import java.util.Arrays;

import org.expeditee.settings.experimental.ExperimentalFeatures;


public class Help { 
	
	// contexts
	public static final int background = 0, item = 1, action = 2;
	
	// mouse buttons
	public static final int left = 0, middle = 1, right = 2;
	private static final char[] buttons = { 'L', 'M', 'R' };
	
	// keyboard modifiers
	public static final int none = 0, control = 1, shift = 2;
	private static final String[] modifiers = { "  ", " ^", " +", "^+" };
	
	// settings
	public static final int panning = 1;
	
	// separator between command and description
	private static final String separator = ": ";
	
	private static final void setButtonText(String[][] button, String text) {
		for(String[] s : button) {
			Arrays.fill(s, text);
		}
	}
	
	// help text
	private static final String[][][][] helpText = new String[3][3][4][2];
	static {
    	setButtonText(helpText[background][left], "Go back");
    	helpText[background][left][control | shift][panning] = helpText[background][left][shift][panning] = "Drag to pan";
    	helpText[background][left][control | shift][none] = helpText[background][left][control][none] = helpText[background][left][shift][none] = "Go forward";
    	setButtonText(helpText[background][middle], "Create arrow");
    	setButtonText(helpText[background][right], "Create rectangle");
    	
    	setButtonText(helpText[item][left], "Follow link");
    	setButtonText(helpText[item][middle], "Pickup");
    	setButtonText(helpText[item][right], "Copy");
    	
    	setButtonText(helpText[action][left], "Run action");
    	setButtonText(helpText[action][middle], "Pickup");
    	setButtonText(helpText[action][right], "Copy");
	}
	
	public static final String padding = "                                        ";
	
	public static void updateStatus() {
		int context = FrameUtils.getCurrentItem() == null ? 0 : FrameUtils.getCurrentItem().hasAction() ? 2 : 1;
		int mod = (FrameMouseActions.isControlDown() ? 1 : 0) | (FrameMouseActions.isShiftDown() ? 2 : 0);
		int settings = (ExperimentalFeatures.MousePan.get() ? 1 : 0);
		String l = modifiers[mod] + buttons[left] + separator + helpText[context][left][mod][settings];
		String m = modifiers[mod] + buttons[middle] + separator + helpText[context][middle][mod][settings];
		String r = modifiers[mod] + buttons[right] + separator + helpText[context][right][mod][settings];
		MessageBay.setStatus(l + padding.substring(l.length()) + m + padding.substring(m.length()) + r + padding.substring(r.length()));
	}

}
